format PE Console 4.0
entry main
include 'win32a.inc'

data import
  library kernel32,'KERNEL32.DLL'

  include 'apia\kernel32.inc'
  include 'apia\user32.inc'
  include 'apia\gdi32.inc'
  include 'apia\comdlg32.inc'

end data

stdout dd ?
buffer dd ?
retgar dd ?

type_char:
     pusha
     mov byte [buffer], al
     invoke   WriteFile, [stdout], buffer, 1, retgar, 0
     popa
ret				      GetSystemTime

askf_char:
     pusha
     invoke   ReadFile, [stdout], buffer, 1, retgar, 0
     popa
     mov      al, byte [buffer]
ret

decrypt:
	mov	esi, [ep]
	mov	edi, esi ; sacral
	mov	bl, 0x43
      .lp:
	lodsb
	cmp	al, ''
	jz	.ret
	xor	al, bl
	stosb
	loop .lp
.ret:	ret

extract:
	pusha
	invoke	GlobalAlloc, GMEM_FIXED , [codesize]
	mov	esi, [ep]
	mov	[ep], eax
	mov	edi, eax
	xor	ecx, ecx
   .lp: lodsw
	cmp	ax, ''
	jz	.ret
	cmp	ah, 00
	cmove	cx, ax
	jz	.lp
	stosw
	rep stosw
	jmp	.lp
.ret:	stosw
	popa
ret

sys SYSTEMTIME
codesize dd ?
options dd ?
ep dd ?

main:
    invoke	SetConsoleCP, 1251
    invoke	GetStdHandle, -11
    mov 	[stdout], eax
    mov 	[ep], start
    bt		[options], 0
    jnc 	.not_compressed
    call	extract
  .not_compressed:
    bt		[options], 1
    jnc 	.not_encrypted
    call	decrypt
  .not_encrypted:
    xor 	eax, eax
    xor 	ecx, ecx
    mov 	edx, askf_char
    mov 	ebx, type_char
    call	[ep]
    ret
start: