
;---[ ]-----------------------------------------
;
;  ?  -      call edx
;  !  -      call ebx
;  +  -   inc eax
;  -  -   dec eax
;  >< -     stosd, std(cld), lodsd
;  (  -   lbl:
;  )  -   loop lbl
;    -   lbl:
;  0..9 -  
;   10 :  call
;
;  call edx : ''
;  call ebx : ''
;  inc eax  : 'f@'
;  dec eax  : 'fH'
;  stosd, std, lodsd : 'ff'
;  stosd, cld, lodsd : 'ff'
;  lbl: (xchg ecx, eax): 'f'
;  loop lbl : ''
;  call
;
;   ,      (EDI)
;     lsd_jump. 
;    .
;      - (,  lsd_jump , 
;  .   )   pop ebx,
;  add lsd_jump, ebx ..  .
;          
;   (lsd_size)  .
;
;---[ ]-----------------------------------------


lsd_jump dd ?
lsd_deep dd ?
lsd_size dd ?

lookup:
   db '?','',0
   db '!','',0
   db '+','f@',0
   db '-','fH',0
   db '','f',0
   db '','f',0
   db '>','',0
   db '<','',0
   db '(','f',1
   db ')','',2
   db 0

;  esi - source code
;  edi - mem buffer
compile:
	push	      edi
	mov	     [lsd_deep], 0
	mov	     [lsd_size], 0
	mov	     [lsd_jump], 0
.lp:
	lodsb
	or	     al, al
	jz	     .finish
	xchg	     al, ah
	push	     esi
	mov	     esi, lookup
  .cmp: lodsb
	test	     al, al
	jz	     .done
	cmp	     al, ah
	jnz	     .skip
	movsw
	lodsb
	add	     [lsd_size], 2
	add	     [lsd_jump], 2
	cmp	     al, 1
	jz	     .f1
	cmp	     al, 2
	jz	     .f2
	;cmp          al, 2
	;jz           .f2
	jmp	     .done
	.skip:
	add	     esi, 3
	jmp	     .cmp
	.done:
	pop	     esi
	jmp	     .lp
.finish:
 .unpsh:cmp	     [lsd_deep], 0
	jz	     .end
	pop	     eax
	pop	     ebx
	push	     eax
	dec	     [lsd_deep]
	jmp	     .unpsh
 .end:	mov	     al, ''
	stosb
	mov	     al, ''
	stosb
	mov	     eax, edi
	pop	     edi
	sub	     eax, edi
	ret

.f1:
	pop	eax
	push	[lsd_jump]
	push	eax
	inc	[lsd_deep]
	mov	[lsd_jump], 0
	jmp	.done

.f2:
	mov	eax, [lsd_jump]
	sub	[edi-1], al
	add byte[edi-1], 2
	cmp	[lsd_deep], 0
	jz	.done
	mov byte[lsd_jump], al
	pop	eax
	pop	ebx
	push	eax
	add byte[lsd_jump], bl
	dec	[lsd_deep]
	jmp	.done