
; )c( o`kante

; LS- implementation
; onto flat assembler

; A

format PE GUI 4.0
entry start

include 'win32a.inc'

data import

  library kernel32,'KERNEL32.DLL',\
	  user32,'USER32.DLL',\
	  gdi32,'GDI32.DLL',\
	  comdlg32, 'comdlg32.dll'

  include 'apia\kernel32.inc'
  include 'apia\user32.inc'
  include 'apia\gdi32.inc'
  include 'apia\comdlg32.inc'

end data

db 0,0

data resource

  IDA_MAIN	= 200
  IDM_MAIN	= 1000

  IDM_NEW	= 1001
  IDM_OPEN	= 1002
  IDM_SAVE	= 1003
  IDM_EXIT	= 1004

  IDM_UNDO	= 1101
  IDM_COPY	= 1102
  IDM_CUT	= 1103
  IDM_PASTE	= 1104
  IDM_DELETE	= 1105
  IDM_SELECTALL = 1106

  IDM_RUN	= 1201
  IDM_PAUSE	= 1202
  IDM_COMPILE	= 1203
  IDM_WAVE	= 1204

  IDM_COMPRESS	= 1401
  IDM_ENCRYPT	= 1402

  IDM_CONTENTS	= 1301
  IDM_ABOUT	= 1303

  IDW_MAIN	= 100


  directory RT_MENU,menus,\
	    RT_ACCELERATOR,accelerators

  resource menus,\
	   IDM_MAIN,LANG_NEUTRAL+SUBLANG_NEUTRAL,main_menu

  resource accelerators,\
	   IDA_MAIN,LANG_RUSSIAN+SUBLANG_DEFAULT,main_keys


  accelerator main_keys,\
	      FVIRTKEY+FNOINVERT+FCONTROL,'N',IDM_NEW,\
	      FVIRTKEY+FNOINVERT+FCONTROL,'O',IDM_OPEN,\
	      FVIRTKEY+FNOINVERT+FCONTROL,'S',IDM_SAVE,\
	      FVIRTKEY+FNOINVERT,VK_F2,IDM_PAUSE,\
	      FVIRTKEY+FNOINVERT,VK_F9,IDM_RUN,\
	      FVIRTKEY+FNOINVERT+FCONTROL,VK_F9,IDM_COMPILE,\
	      FVIRTKEY+FNOINVERT+FCONTROL,VK_F10,IDM_WAVE,\
	      FVIRTKEY+FNOINVERT,VK_F1,IDM_CONTENTS,\
	      FVIRTKEY+FNOINVERT,VK_F12,IDM_ABOUT,\
	      FVIRTKEY+FNOINVERT+FALT,'X',IDM_EXIT

    _ equ ,09h,

   menu main_menu
       menuitem '&File',0,MFR_POPUP
		menuitem '&New' _ 'Ctrl+N',IDM_NEW
		menuseparator
		menuitem '&Open' _ 'Ctrl+O',IDM_OPEN
		menuitem '&Save' _ 'Ctrl+S',IDM_SAVE
		menuseparator
		menuitem 'E&xit' _ 'Alt+X',IDM_EXIT,MFR_END
       menuitem '&Start',0,MFR_POPUP
		menuitem '&Run' _ 'F9',IDM_RUN
		menuitem '&Pause' _ 'F2',IDM_PAUSE
		menuseparator
		menuitem '&Make executable' _ 'Ctrl+F9',IDM_COMPILE
		menuitem '&Make music' _ 'Ctrl+F10',IDM_WAVE,MFR_END
       menuitem '&Options',0,MFR_POPUP
		menuitem '&Compress' _ '(RLE)',IDM_COMPRESS
		menuitem '&Encrypt' _ '(key 43)',IDM_ENCRYPT
		menuseparator
		menuitem '&Life limit'_ '(1 day)',IDM_COMPILE,MFR_END
       menuitem '&Help',0,MFR_POPUP + MFR_END
		menuitem '&Contents' _ 'F1',IDM_CONTENTS
		menuseparator
		menuitem '&About...' _ 'F12',IDM_ABOUT,MFR_END


end data

  _title db '',0
  _wclass db 'D Window',0
  _pclass db 'EDIT',0
  _eclass db 'DEDIT',0

  _font db 'Courier New Cyr',0

  _pause db '&Pause',0x09,'F2',0
  _resum db '&Resume',0x09,'F2',0
  _run db '&Run',0x09,'F9',0
  _stop db '&Stop',0x09,'F9',0

  _stub_name db 'stub',0
  _out_name  db 'a.exe',0
  _wav_name  db 'music.wav',0

  _txt_extension db 'txt',0

  _about_text db '  1.1 ( LS-)',13,10,\
		 '   ',13,10,13,10,\
		 'o`kante',0
  _about_title db '  LS-',0

  _help_file db 'help.txt',0

  wcw WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,COLOR_BTNFACE+1,NULL,_wclass

  include 'lsd.inc'

  start:
	invoke	GetModuleHandle,0
	mov	[wcw.hInstance], eax
	mov	[wce.hInstance], eax
	invoke	LoadIcon,0,IDI_APPLICATION
	mov	[wcw.hIcon],eax
	invoke	LoadMenu, [wcw.hInstance], IDM_MAIN
	mov	[hMenu], eax
	invoke	LoadCursor,0,IDC_ARROW
	mov	[wcw.hCursor],eax
	invoke	RegisterClass,wcw
	invoke	GetClassInfo, [wcw.hInstance], _pclass, wce
	push	[wce.lpfnWndProc]
	pop	[old_editproc]
	push	[wcw.hInstance]
	pop	[wce.hInstance]
	mov	[wce.lpszClassName], _eclass
	mov	[wce.lpfnWndProc], EditProc
	invoke	RegisterClass,wce
	invoke	LoadAccelerators,[wcw.hInstance],IDA_MAIN
	mov	[hAcc], eax
	invoke	CreateWindowEx,0,_wclass,_title,WS_VISIBLE+WS_DLGFRAME+WS_SYSMENU,128,128,400,300,NULL,[hMenu],[wcw.hInstance],NULL
	mov	[hWnd], eax
	invoke	GetClientRect,[hWnd],rc
	sub	[rc.right], 8
	sub	[rc.bottom], 8
	invoke	CreateWindowEx,0,_eclass,NULL,WS_VISIBLE+WS_CHILD+ES_MULTILINE+WS_VSCROLL+ES_AUTOVSCROLL,4,4,[rc.right],[rc.bottom],[hWnd],NULL,[wcw.hInstance],NULL
	mov	[hEdit], eax
	invoke	CreateFont,16,0,0,0,0,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY ,FIXED_PITCH+FF_DONTCARE,_font
	mov	[hFont], eax
	invoke	SendMessage,[hEdit], WM_SETFONT, [hFont], FALSE
	mov	[minfo.cbSize], sizeof.MENUITEMINFO
	mov	[minfo.fMask], MIIM_TYPE
	mov	[minfo.fType], MFT_STRING
	mov	[sRunin], 0
	invoke	SendMessage, [hEdit], EM_GETHANDLE, 0, 0
	mov	[eSource], eax
	invoke	LocalAlloc, LMEM_MOVEABLE, 65535
	mov	[eExecut], eax
	mov	[ofn.lStructSize],sizeof.OPENFILENAME
	mov	eax,[hWnd]
	mov	[ofn.hwndOwner],eax
	mov	eax,[wcw.hInstance]
	mov	[ofn.hInstance],eax
	mov	[ofn.lpstrCustomFilter],NULL
	mov	[ofn.nFilterIndex],1
	mov	[ofn.nMaxFile],1000h
	mov	[ofn.lpstrFileTitle],name_buffer
	mov	[ofn.nMaxFileTitle],100h
	mov	[ofn.lpstrInitialDir],NULL
	mov	[ofn.lpstrDefExt],_txt_extension
	mov	[oCompress], 0
	mov	[oEncrypt], 0
	xor	eax, eax
  msg_loop:
	invoke	GetMessage,msg,NULL,0,0
	or	eax,eax
	jz	end_loop
	invoke	TranslateAccelerator,[hWnd],[hAcc],msg
	or	eax,eax
	jnz	msg_loop
	invoke	TranslateMessage,msg
	invoke	DispatchMessage,msg
	jmp	msg_loop
  end_loop:
	invoke	ExitProcess,[msg.wParam]

proc WindowProc hwnd,wmsg,wparam,lparam
	push	ebx esi edi
	mov	eax, [wmsg]
	cmp	eax, WM_DESTROY
	jz	.wmdestroy
	cmp	eax, WM_COMMAND
	jz	.wmcommand
	cmp	eax, WM_INITMENU
	jz	.initmenu
  .default:
	invoke	DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
	jmp	.finish
  .wmdestroy:
	invoke	PostQuitMessage,0
	xor	eax,eax
	jmp	.finish
  .wmcommand:
	mov	eax, [wparam]
	and	eax, 0FFFFh
	cmp	eax, IDM_EXIT
	je	.wmdestroy
	cmp	eax, IDM_COMPILE
	je	.compile
	cmp	eax, IDM_WAVE
	je	.wave
	cmp	eax, IDM_RUN
	je	.execute
	cmp	eax, IDM_PAUSE
	je	.pause
	cmp	eax, IDM_OPEN
	je	.open
	cmp	eax, IDM_SAVE
	je	.save
	cmp	eax, IDM_CONTENTS
	je	.showhelp
	cmp	eax, IDM_ABOUT
	je	.about
	cmp	eax, IDM_COMPRESS
	je	.compress
	cmp	eax, IDM_ENCRYPT
	je	.encrypt
	jmp	.default
  .showhelp:
	nop
	jmp	.finish
  .about:
	invoke	MessageBox, [hWnd], _about_text, _about_title, 64
	jmp	.finish
  .open:
	invoke	GetOpenFileName, ofn
	test	eax, eax
	jne	.open_ok
	jmp	.finish
     .open_ok:
	call	m_open_file
	jmp	.finish
  .save:
	invoke	GetSaveFileName, ofn
	test	eax, eax
	jne	.save_ok
	jmp	.finish
     .save_ok:
	call	m_save_file
	jmp	.finish
  .compile:
	call	m_make
	jmp	.finish
     .wave:
	call	m_make_wav
	jmp	.finish
  .execute:
	cmp	[sRunin], 1
	je	.execute_end
	call	m_compile
	call	set_shell
	invoke	CreateThread, 0, 0, Interpret, 0, THREAD_PRIORITY_NORMAL, hThread
	mov	[hThread], eax
	jmp	.finish
     .execute_end:
	invoke	TerminateThread, [hThread], 0
	call	set_source
	mov	[sRunin], 0
	jmp	.finish
  .pause:
	cmp	[sPause], 0
	je	.pause_yes
	invoke	ResumeThread, [hThread]
	mov	[sPause], 0
	jmp	.finish
      .pause_yes:
	invoke	SuspendThread, [hThread]
	mov	[sPause], 1
	jmp	.finish
  .compress:
	btc	[oCompress], 0
	btr	[oEncrypt], 0
	jmp	.finish
  .encrypt:
	btc	[oEncrypt], 0
	btr	[oCompress], 0
	jmp	.finish
  .initmenu:
	cmp	[oCompress], 1
	jnz	.n00
	invoke	CheckMenuItem, [hMenu], IDM_COMPRESS ,MF_CHECKED
	jmp	.n01
     .n00:
	invoke	CheckMenuItem, [hMenu], IDM_COMPRESS ,MF_UNCHECKED
     .n01:
	cmp	[oEncrypt], 1
	jnz	.n02
	invoke	CheckMenuItem, [hMenu], IDM_ENCRYPT ,MF_CHECKED
	jmp	.n03
     .n02:
	invoke	CheckMenuItem, [hMenu], IDM_ENCRYPT ,MF_UNCHECKED
     .n03:
	mov	[minfo.cbSize], sizeof.MENUITEMINFO
	mov	[minfo.fMask], MIIM_TYPE
	mov	[minfo.fType], MFT_STRING
	pusha
	mov	ebx, _stop
	mov	edx, _run
	cmp	[sRunin], 1
	cmove	eax, ebx
	cmovnz	eax, edx
	mov	[minfo.dwTypeData], eax
	popa
	invoke	SetMenuItemInfo,[hMenu], IDM_RUN,FALSE,minfo
	pusha
	mov	eax, minfo.dwTypeData
	mov	ebx, _resum
	mov	edx, _pause
	cmp	[sPause], 1
	cmove	eax, ebx
	cmovnz	eax, edx
	mov	[minfo.dwTypeData] ,eax
	popa
	invoke	SetMenuItemInfo,[hMenu], IDM_PAUSE,FALSE,minfo
	jmp	.finish
  .finish:
	pop	edi esi ebx
	ret
endp

proc m_compile
	invoke	SendMessage, [hEdit], EM_GETHANDLE, 0, 0
	mov	[eSource], eax
	invoke	LocalLock, [eSource]
	pusha
	mov	esi, eax
	mov	edi, textbuff
	call	compile
	mov	[CodeSize], eax
	popa
	invoke	LocalUnlock, [eSource]
	ret
endp

proc m_make
	call	m_compile
	btr	[cOptions], 0
	btr	[cOptions], 1
	cmp	[oCompress], 1
	jne	.skip_compress
	pusha
	mov	edx, [CodeSize]
	mov	[ExtractedSize], edx
	bts	[cOptions], 0
	add	edx, textbuff
	mov	esi, textbuff
	call	compress
	mov	[CodeSize], eax
	popa
  .skip_compress:
	cmp	[oEncrypt], 1
	jne	.skip_encrypt
	pusha
	bts	[cOptions], 1
	mov	bl, 0x43
	mov	ecx, [CodeSize]
	mov	esi, textbuff
	call	encrypt
	popa
  .skip_encrypt:
	invoke	CreateFile, _out_name, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	mov	[hOut], eax
	pusha
	mov	esi, textbuff
	mov	edx, [CodeSize]
	call	make
	popa
	invoke	CloseHandle, [hOut]
	ret
endp

proc m_make_wav
	call	m_compile
	invoke	CreateFile, _wav_name, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	mov	[hOut], eax
	pusha
	mov	esi, textbuff
	mov	edx, [CodeSize]
	call	wav
	popa
	invoke	CloseHandle, [hOut]
	ret
endp

proc m_open_file
	invoke	CreateFile, name_buffer, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	mov	[hOut], eax
	mov	[Garbage+1], 0
	mov	[Garbage+2], 0
	mov	[Garbage+3], 0
     .lp:
	invoke	ReadFile, [hOut], Garbage, 1, RetGarb, 0
	nop
	nop
	cmp	[RetGarb], 0
	je	.end
	invoke	SendMessage, [hEdit], WM_CHAR, [Garbage], 0
	jmp	.lp
    .end:
	invoke	CloseHandle, [hOut]
	ret
endp

proc m_save_file
	invoke	SendMessage, [hEdit], WM_GETTEXTLENGTH, 0, 0
	mov	[CodeSize], eax
	invoke	CreateFile, name_buffer, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	mov	[hOut], eax
	invoke	SendMessage, [hEdit], EM_GETHANDLE, 0, 0
	mov	[eSource], eax
	invoke	LocalLock, [eSource]
	invoke	WriteFile, [hOut], eax, [CodeSize], RetGarb, 0
	nop
	nop
	nop
	invoke	LocalUnlock, [eSource]
	invoke	CloseHandle, [hOut]
	ret
endp

proc set_source
	invoke	SendMessage, [hEdit], EM_SETHANDLE, [eSource], 0
	ret
endp

proc set_shell
	invoke	SendMessage, [hEdit], EM_SETHANDLE, [eExecut], 0
	ret
endp

TypeChar:
	pusha
	xor	ah, ah
	invoke	SendMessageTimeout, [hEdit], WM_CHAR, eax, 0, 1, 10, 0
	popa
ret

AskChar:
	pusha
	mov	[sAsKey], 1
	invoke	SuspendThread, [hThread]
	popa
	mov	al, [cChar]
ret

seek:
	pusha
	invoke SetFilePointer, [hOut], eax, 0, FILE_BEGIN
	popa
ret

write1:
	pusha
	mov byte[Garbage], al
	invoke	WriteFile, [hOut], Garbage, 1, RetGarb, 0
	popa
ret

write4:
	pusha
	mov	[Garbage], eax
	invoke	WriteFile, [hOut], Garbage, 4, RetGarb, 0
	popa
ret

proc Interpret cookie
	pop	eax
	mov	[sAsKey], 0
	mov	[sPause], 0
	mov	[sRunin], 1
	mov	edx, AskChar
	mov	ebx, TypeChar
	xor	ecx, ecx
	xor	eax, eax
	call	textbuff
	call	set_source
	mov	[sRunin], 0
     ret
endp

proc EditProc hwnd, wmsg, wparam, lparam
; sledite za rekalmoy
	push	ebx esi edi
	mov	eax, [wmsg]
	cmp	eax, WM_CHAR
	jz	.char
  .default:
	push  [lparam]
	push  [wparam]
	push  [wmsg]
	push  [hwnd]
	call  [old_editproc]
	jmp	.finish
  .char:
	cmp   [sAsKey], 1
	jnz   .default
	mov   al, byte [wparam]
	mov   [cChar], al
	mov   [sAsKey], 0
	invoke ResumeThread, [hThread]
	jmp   .default
  .finish:
	pop	edi esi ebx
	ret
endp

include 'compiler.inc'

section '.didea' data readable writeable

textbuff rb 10*1024*1024
name_buffer rb 100

minfo MENUITEMINFO

hDc   dd ?
hMenu dd ?
hWnd  dd ?
hEdit dd ?
hFont dd ?
hThread dd ?
hOut dd ?
hAcc dd ?

eSource dd ?
eExecut dd ?

Garbage dd ?
RetGarb dd ?

sPause dd ?
sAsKey dd ?
sRunin dd ?

oCompress dw ?
oEncrypt  dw ?
oLifetime dw ?

cChar db ?

CodeSize dd ?
ExtractedSize dd ?
cOptions dd ?

old_editproc dd ?

msg MSG

pt POINT
rc RECT

wce WNDCLASS

ofn OPENFILENAME

first_line dd ?



